fit.COP.GOF <-
function(y,x.cop,group=NULL,nboot=1000) {
  
  if (is.null(group)) {
    rho = NULL
    rho.se = NULL
    
    mu.est = glm(y~x.cop,family='binomial')$fitted.values
    chi.stat.obs = sum( (y-mu.est)^2/(mu.est*(1-mu.est)))

    ny = length(mu.est)
    ym = bindata::rmvbin(nboot,margprob=mu.est)
 
    chi.stat.boot = numeric(nboot)
    for (iii in 1:nboot) {
        mus = glm(ym[iii,]~x.cop,family='binomial')$fitted.values
        chi.stat.boot[iii] = sum((ym[iii,]-mus)^2/(mus*(1-mus)))
    }     
     
    p.value = mean(c(chi.stat.boot, chi.stat.obs) >= chi.stat.obs)
  } else {
    
    group = as.numeric(as.factor(group))
    
    ind = sort.list(group)
    y = y[ind]
    x.cop = x.cop[ind]
    group = group[ind]
  
    fit0 = geepack::geeglm(y~x.cop,id=group,family='binomial',corstr='exchangeable')
    mu.est = fit0$fitted.values 
    chi.stat.obs = sum( (y-mu.est)^2/(mu.est*(1-mu.est)))
    rho = summary(fit0)$corr$Estimate
    rho.se = summary(fit0)$corr$Std.err
    
    ny = length(mu.est)
    ym = fit.COP.sim.data(mu.est,nboot,group,rho)
 
    chi.stat.boot = numeric(nboot)
    for (iii in 1:nboot) {
       mus = geepack::geeglm(ym[iii,]~x.cop,id=group,family='binomial',corstr='exchangeable')$fitted.values
       chi.stat.boot[iii] = sum((ym[iii,]-mus)^2/(mus*(1-mus)))
    }
  
    p.value = mean(c(chi.stat.boot, chi.stat.obs) >= chi.stat.obs)
  }
  
  return(list(chi.stat.obs=chi.stat.obs, df=length(y)-2, p.value=p.value, rho.est=list(est=rho,se=rho.se)))  
  
}
