fit.COP.fitted.values <- function(est,parms) {
  
  n = parms$n
  n.comp = parms$n.comp
  
  if (parms$cop.flag) {
  
      x.cop=parms$x.cop
      x.cop.covariates = parms$x.cop.covariates
      x.covariates = parms$x.covariates
     
      #n.comp = 1+length(x.covariates)
      #n = dim(x.covariates[[1]])[1]
      alpha = est[1]
      beta = est[-1]
      
      pi.matrix = matrix(NA,n,n.comp)
      
      eta0 = (x.cop - x.cop.covariates%*%matrix(beta,ncol=1))
      pi.matrix[,1] = func.logit(exp(alpha)*eta0)
      
      if (n.comp > 1) {
        for (i in 1:(n.comp-1)) {
          eta = x.covariates[[i]]%*%beta
          pi.matrix[,i+1] = func.logit(eta)
        }
      }
    
      mu = apply(pi.matrix,1,parms$h.func)
    
      hprime = matrix(NA, n, n.comp)
      for (i in 1:n.comp) {
        hprime[,i] =  apply(pi.matrix,1,parms$h.prime.func[[i]])
      }
      
      dmu = matrix(0, n, length(est))
      
      tau0 = pi.matrix[,1]*(1-pi.matrix[,1])
      dmu[,1] = exp(alpha)*eta0*hprime[,1]*tau0
      dmu[,2:length(est)] = -exp(alpha)*x.cop.covariates*hprime[,1]*tau0
      
      if (n.comp > 1) {
        for (i in 1:(n.comp-1)) {
          tau0 = pi.matrix[,i+1]*(1-pi.matrix[,i+1])
          dmu[,2:length(est)] = dmu[,2:length(est)] + x.covariates[[i]]*hprime[,i+1]*tau0
        }
      }
      
      
  } else {
    
      x.covariates=parms$x.covariates
     
       beta = est
      
      pi.matrix = matrix(NA,n,n.comp)
      
      for (i in 1:n.comp) {
        eta = x.covariates[[i]]%*%beta
        pi.matrix[,i] = func.logit(eta)
      }
      
      mu = apply(pi.matrix,1,parms$h.func)
      
      hprime = matrix(NA, n, n.comp)
      for (i in 1:n.comp) {
        hprime[,i] =  apply(pi.matrix,1,parms$h.prime.func[[i]])
      }
      
      dmu = matrix(0, n, length(est))
      
      for (i in 1:n.comp) {
        tau0 = pi.matrix[,i]*(1-pi.matrix[,i])
        dmu = dmu + x.covariates[[i]]*hprime[,i]*tau0
      }
      
  }
  
  obj = list(mu=mu, pi.matrix=pi.matrix, dmu=dmu)
  return(obj)
}

  
  