 
fit.COP.jitter <- 
  function(y, x.cop, x.cop.covariates = NULL, x.covariates = NULL, group = NULL, exchangeable = FALSE, 
                cop.flag = TRUE, n.jitter=1, jitter.support=0.9, band.width = NULL, kernel = 'box') {
  
  kernel.types = c('box','gaussian','triangle')  
    
  jitter.obj = NULL
  if (n.jitter >= 2 & cop.flag & !is.null(band.width) & kernel %in% kernel.types) {
    nrep = floor(n.jitter)
    nx = length(x.cop)
    
    yr = rep(y,nrep)
    
    xr.cop.covariates = x.cop.covariates
    xr.covariates = x.covariates
    n.cov = length(x.covariates)
    
    for (i in 1:(nrep-1)) {
      xr.cop.covariates = rbind(xr.cop.covariates,x.cop.covariates)
      if (n.cov > 1) {
        for (j in 1:n.cov) {xr.covariates[[j]] = rbind(xr.covariates[[j]],x.covariates[[j]])}
      }
    }
    
    groupr = NULL
    if (exchangeable) {
      groupi = as.integer(as.factor(group))
      maxi = max(groupi)
      groupr = groupi
      for (i in 1:(nrep-1)) {groupr = c(groupr, groupi + i*maxi)}
    }
    
    xr.cop = NULL
    jitter.points = seq(-band.width/2,band.width/2,length.out=nrep)
    for (di in jitter.points) {xr.cop = c(xr.cop, x.cop+di)}
    
    
    
    if (kernel == 'box') {
      jitter.weights = rep(1,nrep)
    }
    
    if (kernel == 'triangle') {
      b.triangle = band.width/(2 - sqrt(1-jitter.support))
      jitter.weights = sapply(jitter.points, function(x) { max((1-abs(x)/b.triangle)/b.triangle,0) }) 
    }
    
    if (kernel == 'gaussian') {
      jitter.sigma = band.width/(2*qnorm(0.5+jitter.support/2))
      jitter.weights = dnorm(jitter.points,sd=jitter.sigma)
    }
    
    jitter.weights = jitter.weights/sum(jitter.weights)
    
    
    jitter.weights = rep(jitter.weights,each=nrep)
    
    
    jitter.obj = list(yr=yr, xr.cop=xr.cop, xr.cop.covariates = xr.cop.covariates, 
                     xr.covariates = xr.covariates, groupr = groupr, jitter.weights=jitter.weights)   
  }
  
  return(jitter.obj)
  
}  
  