func.COP.bootstrap <-
function(est,parms,group,cor.exch,initial.estimate,exchangeable, quasi.lik, nboot = 200, linear.comb = NULL, control = NULL) {    
  
  estm = matrix(NA, nboot, dim(linear.comb)[1])
  sem = matrix(NA, nboot, dim(linear.comb)[1])
  cor.est = NULL
  
  if (class(initial.estimate)!="function") {initial.estimate=est}
  
  corm = rep(NA,nboot)
  mu = fit.COP.fitted.values(est,parms)$mu
  ys = fit.COP.sim.data(mu,nboot,group,cor.exch)
  
  for (iii in 1:nboot) {
    try({
      fit.COP.objb = func.COP.truncated(ys[iii,],parms$x.cop,parms$x.cop.covariates,parms$x.covariates,
                                       parms$h.func,parms$h.prime.func,initial.estimate,group,exchangeable, 
                                       quasi.lik, parms$cop.flag, linear.comb, control)    
      
      estm[iii,] = fit.COP.objb$coef.est
      sem[iii,] =  fit.COP.objb$coef.se
      if (exchangeable) {corm[iii] =  fit.COP.objb$cor.exch}
    }, silent = TRUE)
  }  
    
  cor.est = c(mean(corm,na.rm=T),sd(corm,na.rm=T))
  names(cor.est) = c('Est','SE')
  zm = estm - matrix(linear.comb%*%est,nrow=nboot,ncol=dim(linear.comb)[1],byrow=T)
  zm = zm/sem
  zvar = apply(zm, 2, function(x) {var(x,na.rm=T)})
  t.df = sapply(zvar, func.make.tdf.f0) 
  
  return(list(t.df=t.df,cor.est=cor.est))  
    
}
