func.COP.bootstrap.fitted.values <-
function(est,parms,new.parms,group,cor.exch,initial.estimate,exchangeable, quasi.lik, nboot = 200, control = NULL) {    
  
  estm = matrix(NA, nboot, new.parms$n)
  sem = matrix(NA, nboot, new.parms$n)
  
  if (class(initial.estimate)!="function") {initial.estimate=est}
 
  mu = fit.COP.fitted.values(est,parms)$mu
  ys = fit.COP.sim.data(mu,nboot,group,cor.exch)
  
  mu.boot = fit.COP.fitted.values(est,new.parms)$mu  
  
  for (iii in 1:nboot) {
    try({
      fit.COP.objb = func.COP.truncated(ys[iii,],parms$x.cop,parms$x.cop.covariates,parms$x.covariates,
                                       parms$h.func,parms$h.prime.func,initial.estimate,group,exchangeable, 
                                       quasi.lik, parms$cop.flag, linear.comb, control)    
      
      fit.COP.fitted.values.obj = fit.COP.fitted.values(fit.COP.objb$coef.est,new.parms)  
      estm[iii,] =   fit.COP.fitted.values.obj$mu  
      sem[iii,] =  func.sqrt0(diag(fit.COP.fitted.values.obj$dmu%*%fit.COP.objb$sigma%*%t(fit.COP.fitted.values.obj$dmu)))
      
    }, silent = TRUE)
  }  
  
  
  zm = estm - matrix(mu.boot,nrow=nboot,ncol=length(mu.boot),byrow=T)
  zm = zm/sem
  zvar = apply(zm, 2, function(x) {var(x,na.rm=T)})
  t.df = sapply(zvar, func.make.tdf.f0) 
  
  return(t.df)  
  
}
