func.COP.lik.dmu <-
function(est,parms) {
  
  x.cop=parms$x.cop
  x.covariates=parms$x.covariates
  
  n = length(x.cop)
  
  x0 = x.covariates[[1]]
  x1 = x.covariates[[2]]
  x2 = x.covariates[[3]]
  
  if (!is.matrix(x0)) {x0 = matrix(x0,n,1)}
  if (!is.matrix(x1)) {x1 = matrix(x1,n,1)}
  if (!is.matrix(x2)) {x2 = matrix(x2,n,1)}
  
  dv = c(dim(x0)[2],dim(x1)[2],dim(x2)[2])
  
  ind0 = (1:dv[1])+1
  ind1 = ((dv[1]+1):(dv[1]+dv[2]))+1
  ind2 = ((dv[1]+dv[2]+1):(dv[1]+dv[2]+dv[3]))+1
  
  eta0 = est[1]*(x.cop - x0%*%est[ind0])
  eta1 = x1%*%est[ind1]
  eta2 = x2%*%est[ind2]
  
  eta0 = as.vector(eta0)
  eta1 = as.vector(eta1)
  eta2 = as.vector(eta2)
  
  p0 = (1/(1 + exp(-eta0))) 
  p1 = (1/(1 + exp(-eta1))) 
  p2 = (1/(1 + exp(-eta2))) 
  
  mu = (1/(1 + exp(-eta1)))*( (1/(1 + exp(eta0))) + (1/(1 + exp(-eta2)))*(1/(1 + exp(-eta0)))) 
  
  tau0 = p0*(1-p0)
  tau1 = p1*(1-p1)
  tau2 = p2*(1-p2)
  taum = mu*(1-mu)
  
  xi0 = tau0*(1-2*p0)
  xi1 = tau1*(1-2*p1)
  xi2 = tau2*(1-2*p2)
  
  #ys = (y-mu)/taum
  
  x0p = cbind((x.cop - x0%*%est[ind0]),-est[1]*x0)
  
  
  v0 = p1*(p2-1)*tau0
  v1 = (1+p0*(p2-1))*tau1
  v2 = p0*p1*tau2
 
  zm = cbind(diag(v0)%*%x0p,diag(v1)%*%x1,diag(v2)%*%x2)
  
  return(zm)
}
