predict.fit.COP <-
function(fit.COP.obj, new.data = NULL, alpha.crit = 0.025) {
  
  if (is.null(new.data)) {
      ans =  cbind(fit.COP.obj$fitted.values,fit.COP.obj$fitted.values.se)
      n.sample = dim(ans)[1]
  } else {
    new.parms = fit.COP.obj$parms
    new.parms$x.cop = new.data$x.cop
    new.parms$x.cop.covariates = new.data$x.cop.covariates
    new.parms$x.covariates = new.data$x.covariates
    
    if (!is.null(new.parms$x.cop)) {n.sample = length(new.parms$x.cop)} else {n.sample = dim(new.parms$x.covariates[[1]])[1]}
    new.parms$n = n.sample
     
    fit.COP.fitted.values.obj = fit.COP.fitted.values(fit.COP.obj$est,new.parms)  
    dmu = fit.COP.fitted.values.obj$dmu  
    ans = cbind(fit.COP.fitted.values.obj$mu, func.sqrt0(diag(dmu%*%fit.COP.obj$sigma%*%t(dmu))))
  }
 
  #if (bootstrap) {
  #    t.df = func.COP.bootstrap.fitted.values(fit.COP.obj$est,fit.COP.obj$parms, new.parms, fit.COP.obj$group,
  #                                            fit.COP.obj$cor.exch,fit.COP.obj$initial.estimate, fit.COP.obj$exchangeable, 
  #                                            fit.COP.obj$quasi.lik, nboot, fit.COP.obj$control) 
  #    ans = cbind(ans,qt(1-alpha.crit,df=t.df),t.df)
  #    colnames(ans) = c('fitted.values','S.E.','t.crit','t.df')
  #} else 
  {
      ans = cbind(ans,rep(qnorm(1-alpha.crit),n.sample))
      colnames(ans) = c('fitted.values','S.E.','z.crit')
  }     
    
  return(ans)
}