summary.fit.COP <-
function(fit.COP.obj) {
  
  coef.table = fit.COP.obj$coef
  log.lik = fit.COP.obj$log.lik
  n = fit.COP.obj$n
  rho = fit.COP.obj$cor.exch
  cor.est = fit.COP.obj$cor.est
  model.df = fit.COP.obj$model.df
  aic = -2*log.lik + 2*model.df
  bic = -2*log.lik + log(n)*model.df
  qic = fit.COP.obj$qic.cop
  qicu = fit.COP.obj$qicu.cop
  n.groups=length(unique(fit.COP.obj$parms$group))
  
  print(fit.COP.obj$coef,digits=5,quote=F)
  
  cat("\n")
    
  if (fit.COP.obj$quasi.lik) {
     cat('Quasi-likelihood estimate:', "\n")
  } else {
    cat('Maximum-likelihood estimate:', "\n")
  }

  if (fit.COP.obj$exchangeable) {
    cat('Exchangeable Correlation: ')
    cat(paste('rho = ',signif(fit.COP.obj$cor.exch,digits=4)),"\n")
    cat('Number of groups = ',n.groups,"\n")
  } else {
      cat('Independence assumed',"\n")
  }
  
  cat('N = ',n,'; model DF = ',model.df,"\n")
  if (is.null(qic)) {
    cat('Log-lik = ',log.lik,'; AIC = ',aic,'; BIC = ',bic,"\n")
  } else {
    cat('Log-lik = ',log.lik,'; QIC = ',qic,'; QICu = ',qicu,"\n")
  }
  
  
  summary.fit.COP.obj = list(
    coef.table = coef.table,
    log.lik = log.lik,
    n = n,
    rho = rho,
    cor.est = cor.est,
    model.df = model.df,
    aic = aic,
    bic = bic,
    n.groups = n.groups)
  
   class(summary.fit.COP.obj) = "summary.fit.COP"
   invisible(summary.fit.COP.obj)

}
